﻿Type=Activity
Version=2.02
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ps As PanelStack
End Sub

Sub Activity_Create(FirstTime As Boolean)
	ps.Initialize(Activity, Me)
	Dim si As StackItem
	Dim m As Map
	m.Initialize
	m.Put("title","I'm the root panel")
	m.Put("edit","Text for panel ")
	si = ps.Add("ps",m)	' usually we pass a map as args so we can store every kind of data
End Sub

Sub ps_Click
	Msgbox("Click messages from panel are routed to Activity","")
End Sub

Sub ps_Add(si As StackItem)
	si.P.LoadLayout("stack")
	si.P.Color = Colors.RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))

	Dim Stack As PanelStack	: Stack = si.P.Tag
	Dim Num As Int			: Num = Stack.Stack.Size -1
	Dim m As Map			: m = si.Arg
	Dim s As String
	Dim l As Label
	' we use the tag of the views to find them, and then we can set some values given by the Arg Map
	l = Stack.GetViewByTag("title")
	s = m.Get("title")
	l.Text = s & " " & Num
	Dim e As EditText
	e = Stack.GetViewByTag("edit")
	e.Text = e.Text & " " & Num
End Sub

Sub bNext_Click
	' the events of the views are intercepted in the activity that use the stack
	Dim m As Map
	m.Initialize
	m.Put("title","I'm the panel ")
	m.Put("edit","Text for panel ")
	ps.Add("ps",m)
End Sub

Sub bEsc_Click
	' similar to KEYCODE_BACK key press, but ask for confirm
	Dim Result As Int
	Dim Num As Int
	Num = ps.Stack.Size -1
	Result  = Msgbox2("Confirm exit from panel " & Num & "?","","Yes","","No",Null)
	If Result = DialogResponse.POSITIVE Then
		ps.RemoveItem(True)	' then EventName + _Esc event is fired but in this case we don't need to intercept
	End If
	If ps.Stack.Size = 0 Then Activity.Finish	' at the end of stack we can close the Activity
End Sub

Sub ps_Close(si As StackItem)
	' as a sample we set the text of the edittext of the previous panel with the one 
	' of the closing panel
	Dim sip As StackItem
	Dim e,ep As EditText
	e = ps.GetPanelViewByTag(si.P,"edit")
	If si.Prev <> Null Then
		sip = si.Prev
		ep = ps.GetPanelViewByTag(sip.P,"edit")
		ep.Text = e.Text
	Else
		ToastMessageShow(e.Text, False)
	End If
End Sub

Sub bOk_Click
	ps.RemoveItem(False)	' then EventName + _Close event is fired
	If ps.Stack.Size = 0 Then Activity.Finish	' at the end of stack we can close the Activity
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress(KeyCode As Int) As Boolean
	' we must intercept KEYCODE_BACK key press to close the stack with apected behavior
	Return ps.KeyPress(KeyCode)
End Sub 

